#ifndef _GBITTEXT_H_
#define _GBITTEXT_H_

#include <graph.h>

class Gbittext: public virtual Graph
{
    public:
    	Gbittext ();			// constructor
    	Gbittext (int vmode);		// constructor with video mode
    	
    	void drawchar (int ascii); 	// draw one char
	void settextpos (int x, 	// define next drawing pos
	    int y);
	void settextwin (int x1, 	// define maximum drawing pos.
	    int y1, int x2, int y2);
	void settextcolors (int fg,	// define drawing colors
	    int bg);
	    
	int putc (int ascii);		// put character
	int puts (const char *s);	// put string
	
    	int putstring ();		// flush string rest
	
    private:
    	void error (const char *msg,	// print error msg and die
    	    ...);
    	    
	int minx, miny, maxx, maxy;	// min/max drawing positions
    	int x, y;			// next drawing position
    	int fg, bg;			// fore/background colors
    	char *outstring;		// string to display
};

#endif
