#ifndef _GRAPH_H_
#define _GRAPH_H_

class Graph
{
    public:
    	Graph ();			// default constr.
    	Graph (int mode);		// constructor with video mode
    	virtual ~Graph ();		// destructor
    	
    	void clearscreen ();		// clear whole screen
    	void drawline (int x1, int	// draw a line
    	    y1, int x2, int y2);
    	void drawpixel (int x, int y);	// draw one pixel
    	int getcolors ();		// return # of colors
    	int getxdim ();			// return hor. # of pixels
    	int getydim ();			// return ver. # of pixels
    	void setcolor (int col);	// define drawing color
    	void setmode (int mode);	// set video mode
    	
    private:
    	void error (const char *fmt,	// print error and die
    	    ...);
	static int initialized;		// vgalib initialized yet?
};

#endif

