#include <stdio.h>
#include <stdlib.h>
#include <gwin.h>
#include <gbittext.h>
#include <vga.h>

#define NLINES 100

void run (int mode, int wait)
{
    Gbittext
    	title (mode);
    Gwin
    	lines;
    char
    	wait_title []   = "Press ^C to quit, space bar for lines",
    	nowait_title [] = "Press ^C to quit";
    double
    	x1 =   0, y1 = 100, dx1 = 5  , dy1 = 7.5,
    	x2 = 200, y2 =   0, dx2 = 2.5, dy2 = 6;
    int
    	linecolor = 1;
    double
    	xx1 [NLINES], yy1 [NLINES],
    	xx2 [NLINES], yy2 [NLINES];
    int
    	current = 0,
    	last = 0;
    	
    title.settextwin (0, title.getydim () - 11,
    		      title.getxdim () - 1, title.getydim () - 1);
    title.settextcolors (0, 15);
    if (wait)
    {
	title.settextpos ( (title.getxdim () - sizeof (wait_title) * 8) / 2, 
	                   0 );
    	title.puts (wait_title);
    }
    else
    {
	title.settextpos ( (title.getxdim () - sizeof (nowait_title) * 8) / 2, 
	                   0 );
    	title.puts (nowait_title);
    }
    
    lines.setscreencoord (0, 0, lines.getxdim () - 1, lines.getydim () - 12);
    lines.setvirtualcoord (0, 0, 1000, 1000);
    lines.border ();
    
    for (current = 0; current < NLINES - 1; current++)
    {
    	if (wait)
	    vga_getch ();   
    	lines.setcolors (linecolor, 0);
    	if (++linecolor == lines.getcolors () - 1)
    	    linecolor = 1;
    	    
    	x1 += dx1;
    	if (x1 > 1000 || x1 < 0)
    	    dx1 = -dx1;
    	y1 += dy1;
    	if (y1 > 1000 || y1 < 0)
    	    dy1 = -dy1;
    	x2 += dx2;
    	if (x2 > 1000 || x2 < 0)
    	    dx2 = -dx2;
    	y2 += dy2;
    	if (y2 > 1000 || y2 < 0)
    	    dy2 = -dy2;
    	    
    	xx1 [current] = x1;
    	yy1 [current] = y1;
    	xx2 [current] = x2;
    	yy2 [current] = y2;
    	
    	lines.drawline (x1, y1, x2, y2);
    }
    
    while (1)
    {
    	if (wait)
	    vga_getch ();    
    	lines.setcolors (0, 0);
    	lines.drawline (last [xx1], last [yy1], last [xx2], last [yy2]);
    	last++;
    	last %= NLINES;
    	
    	lines.setcolors (linecolor, 0);
    	if (++linecolor == lines.getcolors () - 1)
    	    linecolor = 1;
    	    
    	x1 += dx1;
    	if (x1 > 1000 || x1 < 0)
    	    dx1 = -dx1;
    	y1 += dy1;
    	if (y1 > 1000 || y1 < 0)
    	    dy1 = -dy1;
    	x2 += dx2;
    	if (x2 > 1000 || x2 < 0)
    	    dx2 = -dx2;
    	y2 += dy2;
    	if (y2 > 1000 || y2 < 0)
    	    dy2 = -dy2;
    	    
    	current++;
    	current %= NLINES;
    	
    	xx1 [current] = x1;
    	yy1 [current] = y1;
    	xx2 [current] = x2;
    	yy2 [current] = y2;
    	
    	lines.drawline (x1, y1, x2, y2);
    }
}

int main (int argc, char **argv)
{
    int
    	mode;
    	
    if (argc < 2)
    {
    	puts ("Usage: walkline videomode [-wait]\n"
    	      "where: videomode - 1..8, video mode to use\n"
    	      "       -wait     - will cause a wait for <any key> while "
    	      					"displaying\n");
    	exit (1);
    }
    if (! (mode = atoi (argv [1])) || mode < 1 || mode > 8 )
    {
    	printf ("walkline: bad video mode %s, allowed: 1 to 8\n", 
    		argv [1]);
    	exit (1);
    }
    if ( (argc > 2) && (!strcmp (argv [2], "-wait")) )
    	run (mode, 1);
    else
	run (mode, 0);
	
    return (0);
}
